Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPCrossover.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPCrossover.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPCrossover.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -46,4 +46,7 @@
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
     }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
+    }
 
     [StorableConstructor]
@@ -55,12 +58,13 @@
       Parameters.Add(new LookupParameter<IntegerVector>("Child", "The child vector resulting from the crossover.", "Assignment"));
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic crossover operators."));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
     }
 
     public sealed override IOperation Apply() {
-      ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
+      ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue, ProblemInstanceParameter.ActualValue);
       return base.Apply();
     }
 
-    protected abstract IntegerVector Cross(IRandom random, ItemArray<IntegerVector> parents);
+    protected abstract IntegerVector Cross(IRandom random, ItemArray<IntegerVector> parents, GQAPInstance problemInstance);
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/GQAPPathRelinking.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -34,46 +34,11 @@
   [Item("GQAPPathRelinking", "Operator that performs path relinking between two solutions. It is described in Mateus, G., Resende, M., and Silva, R. 2011. GRASP with path-relinking for the generalized quadratic assignment problem. Journal of Heuristics 17, Springer Netherlands, pp. 527-565.")]
   [StorableClass]
-  public class GQAPPathRelinking : GQAPCrossover, IQualitiesAwareGQAPOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator,
-  IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-  IExpectedRandomQualityAwareGQAPOperator, IEvaluatorAwareGQAPOperator {
+  public class GQAPPathRelinking : GQAPCrossover, IQualitiesAwareGQAPOperator {
 
-    public ILookupParameter<BoolValue> MaximizationParameter {
-      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
-    }
     public IScopeTreeLookupParameter<DoubleValue> QualityParameter {
       get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public IScopeTreeLookupParameter<DoubleValue> FlowDistanceQualityParameter {
-      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
-    }
-    public IScopeTreeLookupParameter<DoubleValue> InstallationQualityParameter {
-      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
-    }
-    public IScopeTreeLookupParameter<DoubleValue> OverbookedCapacityParameter {
-      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
-    }
-    public ILookupParameter<DoubleArray> DemandsParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Demands"]; }
-    }
-    public ILookupParameter<DoubleArray> CapacitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
-    }
-    public ILookupParameter<DoubleMatrix> WeightsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Weights"]; }
-    }
-    public ILookupParameter<DoubleMatrix> DistancesParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Distances"]; }
-    }
-    public ILookupParameter<DoubleMatrix> InstallationCostsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
-    }
-    public IValueLookupParameter<DoubleValue> TransportationCostsParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
-    }
-    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
-    }
-    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
-      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
+    public IScopeTreeLookupParameter<Evaluation> EvaluationParameter {
+      get { return (IScopeTreeLookupParameter<Evaluation>)Parameters["Evaluation"]; }
     }
 
@@ -87,17 +52,6 @@
     public GQAPPathRelinking()
       : base() {
-      Parameters.Add(new LookupParameter<BoolValue>("Maximization", GeneralizedQuadraticAssignmentProblem.MaximizationDescription));
-      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", GQAPEvaluator.QualityDescription));
-      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("FlowDistanceQuality", GQAPEvaluator.FlowDistanceQualityDescription));
-      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("InstallationQuality", GQAPEvaluator.InstallationQualityDescription));
-      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("OverbookedCapacity", GQAPEvaluator.OverbookedCapacityDescription));
-      Parameters.Add(new LookupParameter<DoubleArray>("Demands", GeneralizedQuadraticAssignmentProblem.DemandsDescription));
-      Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", GeneralizedQuadraticAssignmentProblem.WeightsDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", GeneralizedQuadraticAssignmentProblem.DistancesDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", GeneralizedQuadraticAssignmentProblem.InstallationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
-      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<Evaluation>("Evaluation", GQAP.EvaluationDescription));
       Parameters.Add(new ValueParameter<PercentValue>("CandidateSizeFactor", "(η) Determines the size of the set of feasible moves in each path-relinking step relative to the maximum size. A value of 50% means that only half of all possible moves are considered each step.", new PercentValue(0.5)));
     }
@@ -107,8 +61,6 @@
     }
 
-    public static IntegerVector Apply(IRandom random, ItemArray<IntegerVector> parents, BoolValue maximization, ItemArray<DoubleValue> qualities,
-      ItemArray<DoubleValue> flowDistanceQualities, ItemArray<DoubleValue> installationQualities, ItemArray<DoubleValue> overbookedCapacities,
-      DoubleArray demands, DoubleArray capacities, DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
-      DoubleValue transportationCosts, DoubleValue expectedRandomQuality, DoubleValue candidateSizeFactor, IGQAPEvaluator evaluator) {
+    public static IntegerVector Apply(IRandom random, ItemArray<IntegerVector> parents, ItemArray<DoubleValue> qualities,
+      GQAPInstance problemInstance, double candidateSizeFactor) {
       if (random == null) throw new ArgumentNullException("random", "No IRandom provider is given.");
       if (parents == null || !parents.Any()) throw new ArgumentException("No parents given for path relinking.", "parents");
@@ -117,20 +69,19 @@
       if (qualities == null || qualities.Length == 0) throw new ArgumentException("The qualities are not given.", "qualities");
       if (qualities.Length != parents.Length) throw new ArgumentException(String.Format("There are a different number of parents ({0}) than quality values ({1})", parents.Length.ToString(), qualities.Length.ToString()));
-
+      
       var source = parents[0];
       var target = parents[1];
       IntegerVector result;
-      double resultQuality, resultFDQ, resultIQ, resultOC;
+      double resultQuality;
 
-      int betterParent = 1;
-      if ((maximization.Value && qualities[0].Value >= qualities[1].Value)
-        || (!maximization.Value && qualities[0].Value <= qualities[1].Value))
-        betterParent = 0;
+      int betterParent = (qualities[0].Value <= qualities[1].Value) ? 0 : 1;
 
       result = (IntegerVector)parents[betterParent].Clone();
       resultQuality = qualities[betterParent].Value;
-      resultFDQ = flowDistanceQualities[betterParent].Value;
-      resultIQ = installationQualities[betterParent].Value;
-      resultOC = overbookedCapacities[betterParent].Value;
+
+      var demands = problemInstance.Demands;
+      var capacities = problemInstance.Capacities;
+
+      var cmp = new IntegerVectorEqualityComparer();
 
       var pi_prime = (IntegerVector)source.Clone();
@@ -140,26 +91,23 @@
 
       while (phi.Any()) {
-        var B = new List<GQAPSolution>();
+        var B = new List<Tuple<GQAPSolution, double>>();
         foreach (var v in phi) {
           int oldLocation = pi_prime[v];
           pi_prime[v] = target[v];
-          var pi2 = makeFeasible(random, pi_prime, v, nonFix, demands, capacities);
+          var pi2 = MakeFeasible(random, pi_prime, v, nonFix, demands, capacities);
           pi_prime[v] = oldLocation;
 
-          double currentFDQ, currentIQ, currentOC;
-          evaluator.Evaluate(pi2, weights, distances, installationCosts, demands, capacities,
-            out currentFDQ, out currentIQ, out currentOC);
+          var currentEval = problemInstance.Evaluate(pi2);
 
-          if (currentOC <= 0.0) {
-            var quality = evaluator.GetFitness(currentFDQ, currentIQ, currentOC,
-              transportationCosts.Value, expectedRandomQuality.Value);
-            var solution = new GQAPSolution(pi2, new DoubleValue(quality), new DoubleValue(currentFDQ),
-              new DoubleValue(currentIQ), new DoubleValue(currentOC));
-            if (B.Count >= candidateSizeFactor.Value * phi.Count) {
+          if (currentEval.ExcessDemand <= 0.0) {
+            var quality = problemInstance.ToSingleObjective(currentEval);
+
+            var solution = new GQAPSolution(pi2, currentEval);
+            if (B.Count >= candidateSizeFactor * phi.Count) {
               int mostSimilarIndex = -1;
               double mostSimilarValue = 1.0;
               for (int i = 0; i < B.Count; i++) {
-                if (IsBetter(maximization.Value, solution.Quality.Value, B[i].Quality.Value)) {
-                  var similarity = HammingSimilarityCalculator.CalculateSimilarity(solution.Assignment, B[i].Assignment);
+                if (quality < B[i].Item2) {
+                  var similarity = HammingSimilarityCalculator.CalculateSimilarity(solution.Assignment, B[i].Item1.Assignment);
                   if (similarity == 1.0) {
                     mostSimilarIndex = -1;
@@ -172,33 +120,28 @@
               }
               if (mostSimilarIndex >= 0)
-                B[mostSimilarIndex] = solution;
+                B[mostSimilarIndex] = Tuple.Create(solution, quality);
             } else {
               bool contains = false;
               foreach (var b in B) {
-                if (!IntegerVectorEqualityComparer.GetDifferingIndices(solution.Assignment, b.Assignment).Any()) {
+                if (cmp.Equals(solution.Assignment, b.Item1.Assignment)) {
                   contains = true;
                   break;
                 }
               }
-              if (!contains) B.Add(solution);
+              if (!contains) B.Add(Tuple.Create(solution, quality));
             }
           }
         }
         if (B.Any()) {
-          GQAPSolution pi;
-          if (maximization.Value) pi = B.SampleProportional(random, 1, B.Select(x => x.Quality.Value), false).First();
-          else pi = B.SampleProportional(random, 1, B.Select(x => 1.0 / x.Quality.Value), false).First();
-          var diff = IntegerVectorEqualityComparer.GetDifferingIndices(pi.Assignment, target);
+          var pi = B.SampleProportional(random, 1, B.Select(x => 1.0 / x.Item2), false).First();
+          var diff = IntegerVectorEqualityComparer.GetDifferingIndices(pi.Item1.Assignment, target);
           var I = phi.Except(diff);
           var i = I.SampleRandom(random);
           fix.Add(i);
           nonFix.Remove(i);
-          pi_prime = pi.Assignment;
-          if (IsBetter(maximization.Value, pi.Quality.Value, resultQuality)) {
-            result = pi.Assignment;
-            resultQuality = pi.Quality.Value;
-            resultFDQ = pi.FlowDistanceQuality.Value;
-            resultIQ = pi.InstallationQuality.Value;
-            resultOC = pi.OverbookedCapacity.Value;
+          pi_prime = pi.Item1.Assignment;
+          if (pi.Item2 < resultQuality) {
+            result = pi.Item1.Assignment;
+            resultQuality = pi.Item2;
           }
         } else return result;
@@ -209,14 +152,11 @@
     }
 
-    protected override IntegerVector Cross(IRandom random, ItemArray<IntegerVector> parents) {
-      return Apply(random, parents, MaximizationParameter.ActualValue, QualityParameter.ActualValue, FlowDistanceQualityParameter.ActualValue,
-        InstallationQualityParameter.ActualValue, OverbookedCapacityParameter.ActualValue, DemandsParameter.ActualValue,
-        CapacitiesParameter.ActualValue, WeightsParameter.ActualValue, DistancesParameter.ActualValue,
-        InstallationCostsParameter.ActualValue, TransportationCostsParameter.ActualValue,
-        ExpectedRandomQualityParameter.ActualValue, CandidateSizeFactorParameter.Value,
-        EvaluatorParameter.ActualValue);
+    protected override IntegerVector Cross(IRandom random, ItemArray<IntegerVector> parents,
+      GQAPInstance problemInstance) {
+      return Apply(random, parents, QualityParameter.ActualValue, problemInstance,
+        CandidateSizeFactorParameter.Value.Value);
     }
 
-    private static IntegerVector makeFeasible(IRandom random, IntegerVector assignment, int equipment, HashSet<int> nonFix, DoubleArray demands, DoubleArray capacities, int maximumTries = 1000) {
+    private static IntegerVector MakeFeasible(IRandom random, IntegerVector assignment, int equipment, HashSet<int> nonFix, DoubleArray demands, DoubleArray capacities, int maximumTries = 1000) {
       int l = assignment[equipment];
       var slack = ComputeSlack(assignment, demands, capacities);
@@ -250,8 +190,4 @@
       return slack;
     }
-
-    private static bool IsBetter(bool maximization, double quality, double otherQuality) {
-      return maximization && quality > otherQuality || !maximization && quality < otherQuality;
-    }
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/MultiGQAPCrossover.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/MultiGQAPCrossover.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/MultiGQAPCrossover.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -35,5 +35,5 @@
   [Item("MultiGQAPCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
   [StorableClass]
-  public class MultiGQAPCrossover : StochasticMultiBranch<IGQAPCrossover>, IGQAPCrossover {
+  public class MultiGQAPCrossover : StochasticMultiBranch<IGQAPCrossover>, IGQAPCrossover, IProblemInstanceAwareGQAPOperator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -49,4 +49,7 @@
       get { return (ILookupParameter<IntegerVector>)Parameters["Child"]; }
     }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
+    }
 
     [StorableConstructor]
@@ -57,4 +60,6 @@
       Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Parents", "The parent vectors which should be crossed.", "Assignment"));
       Parameters.Add(new LookupParameter<IntegerVector>("Child", "The child vector resulting from the crossover.", "Assignment"));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
+
       foreach (Type type in ApplicationManager.Manager.GetTypes(typeof(IGQAPCrossover))) {
         if (!typeof(MultiOperator<IGQAPCrossover>).IsAssignableFrom(type))
@@ -79,8 +84,15 @@
       foreach (var op in Operators.OfType<IGQAPCrossover>()) {
         op.ParentsParameter.ActualName = ParentsParameter.Name;
+        op.ParentsParameter.Hidden = true;
         op.ChildParameter.ActualName = ChildParameter.Name;
+        op.ChildParameter.Hidden = true;
       }
       foreach (var op in Operators.OfType<IStochasticOperator>()) {
         op.RandomParameter.ActualName = RandomParameter.Name;
+        op.RandomParameter.Hidden = true;
+      }
+      foreach (var op in Operators.OfType<IProblemInstanceAwareGQAPOperator>()) {
+        op.ProblemInstanceParameter.ActualName = ProblemInstanceParameter.Name;
+        op.ProblemInstanceParameter.Hidden = true;
       }
     }
@@ -88,5 +100,5 @@
     public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one crossover to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
